  ' Lunar Lander2v5.BAS
  ' Lunar Lander For Nostalganauts
  ' Written for for the Colour Maximite 2 by Vegipete
  '   Sound added by BigMik v3
  '   Instruments, sunlight and green landing pad added by Andrew_G
  '   July 2020
  '
  ' v5 - added help
  '    - added sun to moonscape
  '    - added up arrow as a panic stop/start/pause
  '    - added guages
  '    - made Landed.MOD louder
  ' v4 - added adjustment of sound volume and green landing pad
  '    - changed the 'Success' sound file to Landed.MOD
  '
  ' v3 - added sound - by BigMik
  ' v2 - Vegipete:
  '    - bug fix, allow high altitude, add pointer arrow, constants for parameters
  ' v1 - First try
  
  'The program needs:
  'Font #8 = CHR$ 128-131, ^ < \/ > (Defined below)
  'The following should be on the SD card:
  ' "LanderPict.png" - the lander graphic
  ' Landed.mod "The Eagle has landed"
  ' Success.wav - not used in this version but you can try it!
  ' Crash.wav
  
  'Option Explicit
  
  mode 1,8  ' default but still...
  cls
  
  const PADWIDTH = 60
  const GRAVITY = 0.1
  const POWER = 0.5
  const STARTFUEL = 100
  Const True = 1
  const False = 0
  
  Dim Show_Help = False   'True   'Set this to have Help on or off on startup
  dim surface(800)
  DIM Integer Vol_Adj, Mute = False, Pause_It = False
  Dim integer Vol_Start = 5, Vol_Level = Vol_Start
  diM integer H_Angle, V_Angle
  
  PLAY VOLUME Vol_Start, Vol_Start
  
  '***********************************
  ' Build the lander sprites.
  ' The sprite file only contains images of the lander straight up
  ' with and without rocket burn. For nice rotation, 18 more images
  ' are generated, every 5 degrees, from 5 to 90 degrees (clockwise.)
  ' The rest of the circle is done by mirroring the sprite sideways/
  ' vertically/both.
  ' The base image is loaded onto page 2.
  ' Then the 90` rotation is built across the page on a 40 pixel grid.
  ' Finally, the 38 total sprites are then yanked from the page.
  page write 2
  cls
  load png "LanderPict.png"
  
  ' generate the rotations
  for i = 1 to 18
    image rotate 0, 0,40,40,i*40, 0,i*5
    image rotate 0,40,40,40,i*40,40,i*5
  next i
  
  ' populate the sprites
  for i = 1 to 19
    sprite read i,(i-1)*40,0,40,40
    sprite read 20+i,(i-1)*40,40,40,40
  next i
  
  'Parameters for drawing instruments and help
  H_Factor = 10
  V_Factor = 10
  X_Ctr = mm.hres-50
  Y_Ctr = mm.vres-40
  X_Vol = 550         'Volume/Sound controls
  Y_Vol = Y_Ctr
  Y_H = 52
  X_Fuel = 450        'Fuel gauge X location
  Y_Fuel = Y_Ctr
  H_Fuel = 52
  X_Hzt = 325         'Horizontal speedometer X location
  Y_Hzt = Y_Ctr
  X_Vert = 150        'Vertical speedometer
  Y_Vert = Y_Ctr -15
  
  '***********************************
  do
    page write 1
    cls
    
    text MM.HRES/2,10,"Lunar Lander for Nostalganauts","CT",4,1,rgb(brown)
    
    xlander = 400 ' lander coordinates
    ylander = 100
    vxlander = 0  ' lander velocity
    vylander = 0  ' positive UP!
    alander = 1   ' lander active sprite - so we hide the right one
    rlander = 1   ' lander rotation, 1 to 72 = 0 to 355 degrees
    fuel = 0
    xpad = 0      ' left edge of landing pad - set by CreateMoon
    
    DrawStars
    CreateMoon
    DrawMoon
    sprite show alander,xlander,ylander,1
    page copy 1,0,B
    done = 0
    
    do
      ' test for keypresses
      direction = 0
      burn = 0
      Vol_Adj = 0
      if keydown(0) then
        If Timer > 100 then  'to slow down key presses
          Timer = 0
          for i = 1 to keydown(0)
            if keydown(i) = 128 Then                      ' up arrow, pause
              If Pause_It Then
                Pause_It = False
              Else
                Pause_It = True     'Pause and allow changes whilst paused
                vxlander = 0
                vylander = 0
              End If
            End If
            If keydown (i) = 72 or KeyDown (i) = 104 then ' H or h pressed, get HELP
              If Show_Help Then
                Show_Help = False
                Help
                text MM.HRES-10,Y_CTR+28,"Press [H|h] for HELP.","RB",7,1, RGB(Yellow), RGB(Gray)
              Else
                Show_Help = True
                Help
              End If
            end if
            if keydown(i) = 130 then direction =  1       ' left arrow, rotate left
            if keydown(i) = 131 then direction = -1       ' right arrow, rotate right
            if keydown(i) = 43 then Vol_Adj = 5           ' +, increase volume
            if keydown(i) = 45 then Vol_Adj = -5          ' -, decrease volume
            if keydown(i) = 129 Then                      ' down arrow, toggle MUTE
              If Mute Then
                Mute = False
              Else
                Mute = True
              End If
            End If
            if keydown(i) = 32 and fuel > 0 then          ' space, engine on
              burn = 1
              play stop : play tone 100,250,50
            End If
          next i
        End if
      endif
      
      ' adjust and show sound volume
      Vol_Level = Vol_Level + Vol_Adj
      If Vol_Level > 100 then Vol_Level = 100
      If Vol_Level < 0 then Vol_Level = 0
      Box X_Vol+1, Y_Vol-51, 8, 50,,RGB(black), RGB(black)  'Blank our Sound bar
      Text X_Vol+5, Y_Vol+13, "    ", CB, 7,1,RGB(Gray),RGB(GRay)
      Text X_Vol+5, Y_Vol+13, STR$(Vol_Level)+"%", CB, 7,1,RGB(WHITE),RGB(GRay)
      If Mute then
        PLAY VOLUME 0, 0
        Box X_Vol+1, Y_Vol-1-Vol_Level\2, 8, Vol_Level\2,,RGB(Blue), RGB(Blue)
        Text X_Vol+6, Y_Vol+38, "MUTED", CB, 7,1,RGB(RED),RGB(GRay)
      Else
        PLAY VOLUME Vol_Level, Vol_Level
        Text X_Vol+6, Y_Vol+38, "     ", CB, 7,1,RGB(RED),RGB(GRay)
        Box X_Vol+1, Y_Vol-1-Vol_Level\2, 8, Vol_Level\2,,RGB(green), RGB(Green)
      End If
      
      ' adjust rotation
      rlander = rlander + direction
      if rlander > 72 then rlander = rlander - 72
      if rlander <  1 then rlander = rlander + 72
      
      if Pause_It then
        ShowLander(rlander,burn)
        page copy 1,0,B
        Goto Paused
      End If
      
      ' thrust
      if burn > 0 and fuel > 0 then
        fuel = fuel - 1
        angle = (rlander - 1) * PI / 36
        vxlander = vxlander - POWER * sin(angle)
        vylander = vylander + POWER * cos(angle)
      endif
      
      ' gravity
      vylander = vylander - GRAVITY
      
      ' display velocity & fuel
      Box X_Fuel+1, Y_Fuel-51, 8, 50,,RGB(black), RGB(black)  'Blank out fuel guage
      if Fuel > 25 then
        Box X_Fuel+1, Y_Fuel-1-Fuel\2, 8, Fuel\2,,RGB(Yellow), RGB(Yellow)
      Else
        Box X_Fuel+1, Y_Fuel-1-Fuel\2, 8, Fuel\2,,RGB(RED), RGB(RED)
      End if
      Text X_Fuel+5, Y_Fuel+13, "    ", CB, 7,1,RGB(Gray),RGB(GRay)
      Text X_Fuel+5, Y_Fuel+13, STR$(fuel), CB, 7,1,RGB(WHITE),RGB(GRay)
 
      'H_Factor = 10
      Text X_Hzt+3, Y_Hzt+13, "      ", CB,7,1,RGB(Gray),RGB(GRay)
      Text X_Hzt+5, Y_Hzt+13, Str$(vxlander*H_Factor, -2, 1), CB, 7,1,RGB(WHITE),RGB(GRay)
      
      aRC X_Hzt, Y_Hzt, 40, 50-1, 270, 90, RGB(Black)   'Blank out old gauge
      H_Angle = Cint(vxlander*H_Factor)
      if H_Angle < -89 then
        aRC X_Hzt, Y_Hzt, 40,50-1 , 271, 360, RGB(red)
      Else if H_Angle < 0 then
        aRC X_Hzt, Y_Hzt, 40,50-1 , 360+H_Angle, 360, RGB(red)
      End If
      
      if H_Angle > 89 then
        aRC X_Hzt, Y_Hzt, 40,50-1 , 0, 89, RGB(Green)
      Else if H_Angle > 0 then
        aRC X_Hzt, Y_Hzt, 40,50-1 , 0, H_Angle, RGB(Green)
      End If      
      ' ignore special case when H_Angle = 0
      line X_Hzt,Y_Hzt-50,X_Hzt,Y_Hzt-40, ,RGB(White) 'Centre bar
      
      'V_Factor = 10
      Text X_Vert, Y_Vert-10, "      ", CB,7,1,RGB(Gray),RGB(GRay)
      Text X_Vert, Y_Vert-10, Str$(vylander*V_Factor, -2, 1), CB, 7,1,RGB(WHITE),RGB(GRay)
      
      arc X_Vert, Y_Vert, 40,50-1,1, 179, RGB(Black)   'Blank out gauge
      V_Angle = cint(vylander*V_Factor)
      If V_Angle <-89 then
        aRC X_Vert, Y_Vert, 40,50-1 , 91, 179, RGB(yellow)
      Else If V_Angle <0 then
        aRC X_Vert, Y_Vert, 40,50-1 , 90, 90-V_Angle, RGB(yellow)
      End If
      
      if V_Angle > 89 then
        aRC X_Vert, Y_Vert, 40,50-1 , 1, 90, RGB(Gray)
      Else if V_Angle > 0 then
        aRC X_Vert, Y_Vert, 40,50-1 , 90-V_Angle, 90, RGB(GRAY)
      End If
      ' ignore special case when V_Angle = 0           
      line X_Vert+40, Y_Vert, X_Vert+50, Y_Vert,, RGB(White)'Centre bar
     
      xlander = xlander + vxlander
      if xlander < -30 then xlander = xlander + MM.HRES + 20
      if xlander > MM.HRES-10 then xlander = xlander - MM.HRES - 20
      ylander = ylander - vylander
      
      ShowLander(rlander,burn)
      page copy 1,0,B
      
      ' test for landing
      if xlander > -20 and xlander < 780 then       ' no test when off screen
        if ylander > surface(xlander+20) - 32 then  ' touched the surface?
          ShowLander(rlander,0)                     ' engines off
          if xlander > xpad - 5 and xlander < xpad + PADWIDTH - 35 then ' over landing pad?
            if rlander < 3 or rlander > 68 then     ' near vertical?
              if vylander > -2 then                 ' low vertical velocity?
                text xlander+20,ylander-15,"Success!","CT",4,1,rgb(green)
                'Play Stop : Play wav "success.wav"
                Play Stop
                if not Mute then
                  PLAY VOLUME 30, 30  ' Added because Landed.MOD is too quiet
                  Play MODFILE "Landed.Mod"
                  pause 2000
                  Play Stop
                  PLAY VOLUME Vol_Level, Vol_Level
                Endif
              else
                text xlander+20,ylander-40),"Crash!","CT",4,1,rgb(red)
                text xlander+20,ylander-15),"Too fast.","CT",4,1, RGB(White)
                If not Mute then Play Stop : Play wav "crash.wav"
              endif
            else
              text xlander+20,ylander-40),"Crash!","CT",4,1,rgb(red)
              text xlander+20,ylander-15),"Too far off level.","CT",4,1, RGB(White)
              If Not Mute Then Play Stop : Play wav "crash.wav"
            endif
          else
            text xlander+20,ylander-40),"Crash!","CT",4,1,rgb(red)
            text xlander+20,ylander-15),"Missed the pad.","CT", 4,1, RGB(White)
            text xlander+20,ylander-40),"Crash!","CT",4,1,rgb(red)
            text xlander+20,ylander-15),"Missed the pad.","CT", 4,1, RGB(White)
            if not mute then Play Stop : Play wav "crash.wav"
          endif
          done = 1
          page copy 1,0
        endif
      endif
      
Paused:
      pause 50  'This controls the speed of the game
      
    loop until done
    
    page write 0
    text MM.HRES/2,200,"Press [Enter] to go again.","CT",4,1, RGB(White)
    text MM.HRES/2,230,"Press [ESC] to go quit.","CT", 4,1, RGB(White)
    
    do
      k = asc(inkey$)
      if k = 27 then end
      if k = 13 then exit do
    loop
    
    play stop
    sprite hide alander
  loop
  
  '***********************************
sub showlander(n,b)
  
  local x,y
  local offset = 0
  
  if b then offset = 20
  x = xlander+20              ' local copy to deal with sky high lander
  y = ylander
  
  box 0,0,MM.HRES,12,1,0,0    ' erase anything left on pointer row
  arrow$ = " "
  if y < -39 then
    y = -39
    arrow$ = chr$(146)
  endif
  
  if x < -5 then x = -5
  if x > MM.HRES+4 then x = MM.HRES+4
  text x,1, arrow$, "CT"
  
  sprite hide alander
  select case n
    case 1 to 19
      alander = n + offset
      sprite show alander,xlander,y,1,0
    case 20 to 36
      alander = 38-n + offset
      sprite show alander,xlander,y+2,1,2
    case 37 to 55
      alander = n-36 + offset
      sprite show alander,xlander,y+2,1,3
    case 56 to 72
      alander = 74-n + offset
      sprite show alander,xlander,y,1,1
  end select
end sub
  
  '***********************************
Sub Help
  Local Integer Col = RGB(White)
  if not Show_Help then
    Col = RGB(GRAY)
    text MM.HRES-10,Y_CTR+28,"Press [H|h] for HELP.","RB",7,1, RGB(Yellow), RGB(Gray)
  Else
    'Hide any Help text
    text MM.HRES-10,Y_CTR+28,"                      ","RB",7,1, RGB(Gray), RGB(Gray)
  End If
  
  'Show_Keys:   'The variables below are defined above but are retained here to assist
  '  X_Ctr = mm.hres-50
  '  Y_Ctr = mm.vres-40
  
  text X_Ctr,Y_Ctr-12,chr$(128),CB,8,1,Col,RGB(GRay)    'Up  arrow
  text X_Ctr, Y_Ctr-55, "PAUSE",CB, 7,1, Col,RGB(GRay)
  text X_Ctr, Y_Ctr-45, "ON/OFF",CB, 7,1, Col,RGB(GRay)
  
  text X_Ctr,Y_Ctr+27-5,chr$(129),CB,8,1,Col,RGB(GRay)  'Down  "
  text X_Ctr, Y_Ctr+28, "MUTE",CB, 7,1, Col,RGB(GRay)
  text X_Ctr, Y_Ctr+38, "ON/OFF",CB, 7,1, Col,RGB(GRay)
  
  text X_Ctr-5,Y_Ctr+5,chr$(130),RB,8,1,Col,RGB(GRay)   'Left  "
  text X_Ctr-45, Y_Ctr+4, "Rotate",LB, 7,1, Col,RGB(GRay)
  text X_Ctr-45, Y_Ctr+14, "Left",LB, 7,1, Col,RGB(GRay)
  
  text X_Ctr+5,Y_Ctr+5,Chr$(131),LB,8,1,Col,RGB(GRay)   'Right "
  text X_Ctr+15, Y_Ctr+4, "Rotate",LB, 7,1, Col,RGB(GRay)
  text X_Ctr+15, Y_Ctr+14, "Right",LB, 7,1, Col,RGB(GRay)
  
  box X_Ctr - 100, Y_Ctr - 25, 50, 20,,Col, RGB(GRAY)   'Space bar
  text X_Ctr-75, Y_Ctr-15, "Thrust",CM, 7,1,Col,RGB(GRay)
End Sub 'Help
  
sub DrawMoon
  
  for i = 0 to MM.HRES-1
    if i > xpad and i < xpad + PadWidth then
      line i,surface(i),i,MM.VRES-1,1,rgb(grAY)
      line i,surface(i),i,surface(i),1,rgb(green) 'landing pad
    else
      line i,surface(i),i,MM.VRES-1,1,rgb(gray)
      if surface(i+1) > surface(i) then   'This adds sunlight to the lunar surface
        line i, surface(i), i+1, surface(i+1),,RGB(Yellow)
      Else
        line i, surface(i), i+1, surface(i+1),,RGB(Gray)
      End If
    End If
  next i
  
  Help
  
  'Show Instruments:
  '  X_Vol = 550             'Volume/Sound controls
  '  Y_Vol = Y_Ctr
  '  Y_H = 52
  Box X_Vol, Y_Vol-Y_H, 10, Y_H,,RGB(White), RGB(Black)
  'Text X_Vol+4, Y_Vol+28,"VOLUME", CB, 7,1,RGB(WHITE),RGB(GRay)
  Text X_Vol+6, Y_Vol+28, "SOUND", CB, 7,1,RGB(WHITE),RGB(GRay)
  Text X_Vol+20+10, Y_Vol+28, "+ Up", LB, 7,1,RGB(WHITE),RGB(GRay)
  Text X_Vol+20+10, Y_Vol+38, "- Down", LB, 7,1,RGB(WHITE),RGB(GRay)
  Box X_Vol+17+10, Y_Vol+18,11,10,,RGB(WHITE)
  Box X_Vol+17+10, Y_Vol+29,11,10,,RGB(WHITE)
  
  '  X_Fuel = 450        'Fuel gauge X location
  '  Y_Fuel = Y_Ctr      '
  '  H_Fuel = 52
  Box X_Fuel, Y_Fuel-H_Fuel, 10, H_Fuel,,RGB(White), RGB(Black)
  Text X_Fuel+6, Y_Fuel+28, "FUEL", CB, 7,1,RGB(WHITE),RGB(GRay)
  
  '  X_Hzt = 325             'Horizontal speedometer X location
  '  Y_Hzt = Y_Ctr
  Text X_Hzt+6, Y_Vol+28, "HORIZONTAL", CB, 7,1,RGB(WHITE),RGB(GRay)
  Text X_Hzt+6, Y_Vol+38, "VELOCITY", CB, 7,1,RGB(WHITE),RGB(GRay)
  'ARC x, y, r1, [r2], rad1, rad2, Colour
  aRC X_Hzt, Y_Hzt, 40, 50, 270, 90, RGB(Black)   'Blank out gauge
  aRC X_Hzt, Y_Hzt, 40, , 270, 90, RGB(White)
  aRC X_Hzt, Y_Hzt, 50, , 270, 90, RGB(White)
  line X_Hzt-50,Y_Hzt,X_Hzt-40,Y_Hzt, ,RGB(White)
  line X_Hzt+50,Y_Hzt,X_Hzt+40,Y_Hzt, ,RGB(White)
  line X_Hzt,Y_Hzt-50,X_Hzt,Y_Hzt-40, ,RGB(White) 'Centre bar
  text X_Hzt-45,Y_Hzt+10, "-90", CB,7,1,RGB(WHITE),RGB(GRay)
  text X_Hzt+45,Y_Hzt+10, "+90", CB,7,1,RGB(WHITE),RGB(GRay)
  
  '  X_Vert = 150             'Vertical speedometer
  '  Y_Vert = Y_Ctr -15      '25  '-50
  Text X_Vert, Y_Vert+5,  "VERTICAL", CB, 7,1,RGB(WHITE),RGB(GRay)
  Text X_Vert, Y_Vert+15, "VELOCITY", CB, 7,1,RGB(WHITE),RGB(GRay)
  arc X_Vert, Y_Vert, 40,50,0, 180, RGB(Black)   'Blank out gauge
  aRC X_Vert, Y_Vert, 40,  ,0, 180, RGB(White)
  aRC X_Vert, Y_Vert, 50,  ,0, 180, RGB(White)
  line X_Vert, Y_Vert-40, X_Vert, Y_Vert-50,, RGB(White)
  line X_Vert, Y_Vert+40, X_Vert, Y_Vert+50,, RGB(White)
  line X_Vert+40, Y_Vert, X_Vert+50, Y_Vert,, RGB(White)'Centre bar
  Text X_Vert-15, Y_Vert-40, "+90", CB, 7,1,RGB(WHITE),RGB(GRay)
  Text X_Vert-15, Y_Vert+50, "-90", CB, 7,1,RGB(WHITE),RGB(GRay)
end sub
  
  '***********************************
sub CreateMoon
  local height
  
  fuel = STARTFUEL
  
  xpad = int(rnd * 400) + 200 - PADWIDTH/2
  height = 500 - int(rnd * 100)  ' landing pad altitude
  
  for i = 0 to PADWIDTH
    surface(xpad + i) = height
  next i
  
  for i = xpad-1 to 0 step -1
    surface(i) = surface(i+1) + 4.8 - 10*rnd  ' slight bias up
    if surface(i) > MM.VRES-75 then surface(i) = MM.VRES-75
  next i
  
  for i = xpad + PADWIDTH to MM.HRES
    surface(i) = surface(i-1) + 4.8 - 10*rnd  ' slight bias up
    if surface(i) > MM.VRES-75 then surface(i) = MM.VRES-75
  next i
end sub 'CreateMoon
  
  '***********************************
sub DrawStars
  
  for i = 1 to 200
    pixel 800*rnd,500*rnd,map(rnd*255)
  next i
  
end sub
     
  ' AG - Arrows 24x32.bas
  ' Font type    : Full (4 characters)
  ' Font start   : CHR$(128)
  ' Font size    : 24x32 pixels
  ' Memory usage : 388 bytes
  '
DefineFont #8
  04802018 00000000 3C000018 007E0000 0100FF00 990380DB E01807C0 1C70180E
  18183818 08181018 00001800 18000018 00180000 00001800 18000018 00180000
  00001800 18000018 00180000 00001800 00000000 00000000 00000000 00000000
  00000000 00000000 18000018 00180000 00001800 18000018 00180000 00001800
  18000018 00180000 00001800 18100018 18181808 0E38181C 18077018 C09903E0
  0080DB01 7E0000FF 003C0000 00001800 00000000 00000000 00000000 00000000
  00000000 00000000 00000000 00000000 0100E000 800300C0 00000700 1C00000E
  00380000 00007000 FFFFFFFF 0070FFFF 00003800 0E00001C 00070000 00800300
  0000C001 000000E0 00000000 00000000 00000000 00000000 00000000 00000000
  00000000 00000000 00000000 00000000 00000700 01008003 E00000C0 00700000
  00003800 0E00001C FFFFFFFF 0000FFFF 1C00000E 00380000 00007000 C00100E0
  00800300 00000007 00000000 00000000 00000000 00000000 00000000 00000000
  00000000 00000000
End DefineFont